Bug 233770 - Mk/Uses/python.mk: QA lang/python37 as default python3 version
Summary: Mk/Uses/python.mk: QA lang/python37 as default python3 version
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Ports Framework (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Many People
Assignee: Port Management Team
URL:
Keywords: needs-qa
Depends on: 233298 234163 242587
Blocks:
  Show dependency treegraph
 
Reported: 2018-12-04 10:22 UTC by Ruslan Makhmatkhanov
Modified: 2019-12-16 06:30 UTC (History)
9 users (show)

See Also:
koobs: exp-run?


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ruslan Makhmatkhanov freebsd_committer 2018-12-04 10:22:10 UTC
Hello, can we please do an exp-run of python3 ports with python3.7 as default? 
Python3.7 has many exciting features and performance improvements, and I'm using it as default for almost year already with pydata stack and gnome3. 

I'm aware of only two ports that fails to work with python3 - accessibility/accerciser and current version science/py-sckit-learn. I have local patches for both of them, but we need to know all the stoppers. 

Thanks.
Comment 1 Kubilay Kocak freebsd_committer freebsd_triage 2018-12-04 11:46:00 UTC
I'm all for moving as quickly to using the latest and greatest in the Python ecosystem.

However, we need to keep in mind that:

a) The vast majority of Python ports, currently use loose and implicit rather than precise and explicit version specifiers. That is, either; 

  1) Under-specify/declare their version support, with a major class example being "X.Y+", without an upper bound, or
  2) Don't specify version support at all (bare USES=python), used to imprecisely mean something like 'all versions' or 'python 2 and 3'.

b) Python package support for the latest (usually 1-2) and greatest versions is a fairly slow moving target. It takes time and manual interventions upstream, for those later versions to enter the CI ecosystem/configuration into a 'tested by default' status.

c) With the vast majority of Python ports sitting without test suites, an exp-run can only tell us a limited amount about potential issues, and in particularly, not at run-time, in order to give us a good answer to 'is it a good time to switch'.

An exp-run should be a first step, and not the only step/data point, to deciding to move forwards on later versions being a default, no matter how great it would be to do so.

We should consider within that decision other issues such as, but not limited to:

- Support periods (if they differ) between releases
- Time / number of releases since releases
- How to improve Python port version specification / explicitness to make it easier to move default versions without introducing unknown/untestable regressions (until after the fact).

The question I believe we actually need to pose and ultimately answer (outside of the scope of this exp-run/issue) is, what (else) do we need to do to make moving default versions forward a trivial/non-event.

A large part of that question is whether we take an "exclusive allow" vs "exclusive deny" approach to version support in Python ports. Right now we're in 'exclusive deny mode' where most ports are loosely or under specified (incorrectly), until bugs/issues are reported.

@Ruslan Maybe its worth a few of us (python) getting together on IRC to flesh out a plan for this. It'd be great to make it easier for these things to move forward faster in the future too. Think: python default = 3.x, which is a superset of this problem.
Comment 2 Ruslan Makhmatkhanov freebsd_committer 2018-12-04 12:20:39 UTC
Hi Kubilay!

Yes, you are right, this is just the first step in a plan of moving to python3 as default and we already did that in past without much problem - for example switching from 3.5 to 3.6 was quite smooth AFAIR. 

Then we can do more broad exp-run with python 3.7 as default to identify ports that are tied to python 2.x and mark them as such explicitly. This will allow them to work after switching the tree to 3.7 as default.

I can't say how slowly the transition to 3.x is going, but ~1100 ports installed in my system are python3 capable, except the exaile and deluge. And moreover, the current trend for upstream is to drop python 2.x support altogether like we saw it with gnome3, gajim, jupyter-notebook and scikit-learn to name of few. 

While this should work, I'm all for discussing how to simplify the future upgrades. We may chat at weekend if there are no objections.
Comment 3 Kubilay Kocak freebsd_committer freebsd_triage 2018-12-04 12:23:43 UTC
(In reply to Ruslan Makhmatkhanov from comment #2)

Sounds good :)
Comment 4 Antoine Brodin freebsd_committer 2018-12-12 20:22:52 UTC
New failures on 11.2 i386:

+ {"origin"=>"accessibility/accerciser", "phase"=>"package", "errortype"=>"???"}
+ {"origin"=>"archivers/py-attic", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"astro/py-astropy", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"biology/py-biom-format", "flavor"=>"py37", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"databases/py-pymssql", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-datrie", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-efl", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-intbitset", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-jcc", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-llfuse", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-pymtbl", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-python-gitlab", "flavor"=>"py37", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"devel/py-sarge", "flavor"=>"py37", "phase"=>"configure", "errortype"=>"???"}
+ {"origin"=>"devel/py-statgrab", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/pysvn", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/py-PyOpenGL-accelerate", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/py-pyproj", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-PyMetis", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-levmar", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-symcxx", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"net/libproxy-python", "flavor"=>"py37", "phase"=>"stage", "errortype"=>"???"}
+ {"origin"=>"net/py-pynmsg", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"net/py-pypcap", "flavor"=>"py37", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"science/py-mlpy", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"science/py-scikit-learn", "flavor"=>"py37", "phase"=>"build", "errortype"=>"linker_error"}
+ {"origin"=>"security/morphis", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"textproc/py-pyctpp2", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-http-parser", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-url", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}


New failure logs on 11.2 i386:

http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/accerciser-3.22.0.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-attic-0.16_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-astropy-1.1.2_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-biom-format-2.1.7.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pymssql-2.1.3.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-datrie-0.7.1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-efl-1.20.0.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-intbitset-2.3.0_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-jcc-3.0.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-llfuse-1.2_2.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pymtbl-0.4.1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-python-gitlab-1.6.0.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-sarge-0.1.4.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-statgrab-0.7.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/pysvn-py37-1.9.3.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-PyOpenGL-accelerate-3.1.0_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pyproj-1.9.5.1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-PyMetis-2016.2.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-levmar-0.2.2.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-symcxx-0.1.9_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-libproxy-python-0.4.15.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pynmsg-0.4.0.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pypcap-1.2.2.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-mlpy-3.5.0_6.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-scikit-learn-0.20.1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/morphis-0.8.18.6_1.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-pyctpp2-0.12.2_4.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-http-parser-0.8.3.log
http://package23.nyi.freebsd.org/data/112i386-default-PR233770-804-828/2018-12-11_12h24m58s/logs/errors/py37-url-0.4.2.log
Comment 5 commit-hook freebsd_committer 2018-12-12 21:57:55 UTC
A commit references this bug:

Author: rm
Date: Wed Dec 12 21:57:06 UTC 2018
New revision: 487327
URL: https://svnweb.freebsd.org/changeset/ports/487327

Log:
  accessibility/accerciser: fix packaging with python 3.7

  Add upstream patch to fix packaging/runtime with python 3.7

  PR:		233770
  With hat:	gnome

Changes:
  head/accessibility/accerciser/files/
  head/accessibility/accerciser/files/patch-src_lib_accerciser-accerciser.py
Comment 6 Kubilay Kocak freebsd_committer freebsd_triage 2018-12-13 03:07:14 UTC
Will re-assign when if/when next exp-run required

Thank you Antoine!
Comment 7 Antoine Brodin freebsd_committer 2018-12-13 06:19:06 UTC
New failures on 11.2 amd64:

+ {"origin"=>"accessibility/accerciser", "phase"=>"package", "errortype"=>"???"}
+ {"origin"=>"archivers/py-attic", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"astro/py-astropy", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"biology/py-biom-format", "flavor"=>"py37", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"databases/py-pymssql", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-datrie", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-efl", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-intbitset", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-jcc", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-llfuse", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-pymtbl", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-python-gitlab", "flavor"=>"py37", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"devel/py-sarge", "flavor"=>"py37", "phase"=>"configure", "errortype"=>"???"}
+ {"origin"=>"devel/py-statgrab", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/pysvn", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/py-PyOpenGL-accelerate", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/py-pyproj", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-PyMetis", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-levmar", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-symcxx", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"net/libproxy-python", "flavor"=>"py37", "phase"=>"stage", "errortype"=>"???"}
+ {"origin"=>"net/py-pynmsg", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"net/py-pypcap", "flavor"=>"py37", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"science/py-mlpy", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"science/py-scikit-learn", "flavor"=>"py37", "phase"=>"build", "errortype"=>"linker_error"}
+ {"origin"=>"security/morphis", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"textproc/py-pyctpp2", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-http-parser", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-url", "flavor"=>"py37", "phase"=>"build", "errortype"=>"clang"}
Comment 8 Mathieu Arnold freebsd_committer 2018-12-14 09:38:35 UTC
exp-run has not been ok'ed.
Comment 9 Mateusz Piotrowski freebsd_committer 2019-02-13 13:28:19 UTC
What's the current status of the switch to Python 3.7?
Comment 10 Antoine Brodin freebsd_committer 2019-02-13 13:33:13 UTC
(In reply to Mateusz Piotrowski from comment #9)
Waiting for the 30 ports to be fixed ?
Comment 11 commit-hook freebsd_committer 2019-02-14 06:59:17 UTC
A commit references this bug:

Author: antoine
Date: Thu Feb 14 06:58:58 UTC 2019
New revision: 492900
URL: https://svnweb.freebsd.org/changeset/ports/492900

Log:
  Unbreak INDEX with DEFAULT_VERSIONS=python3=3.7

  PR:		233770

Changes:
  head/devel/py-opengrok-tools/Makefile
Comment 12 Antoine Brodin freebsd_committer 2019-02-21 06:47:33 UTC
New failures with DEFAULT_VERSIONS=python=3.7 python3=3.7 (vs 3.6):

+ {"origin"=>"archivers/py-attic", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"astro/py-astropy", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"audio/lv2", "phase"=>"configure", "errortype"=>"configure_error"}
+ {"origin"=>"biology/py-biom-format", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"databases/py-pymssql", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-datrie", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-efl", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-intbitset", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-jcc", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-llfuse", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-osc-lib", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"devel/py-pymtbl", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/py-python-gitlab", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"devel/py-statgrab", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"devel/pysvn", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/luxrender14", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"graphics/py-PyOpenGL-accelerate", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"graphics/py-pyproj", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"mail/py-notmuch", "flavor"=>"py27", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"mail/py-notmuch", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"math/pdal", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-PyMetis", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-levmar", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"math/py-symcxx", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"misc/py-glance", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"net/libproxy-python", "phase"=>"stage", "errortype"=>"???"}
+ {"origin"=>"net/pacemaker1", "phase"=>"package", "errortype"=>"???"}
+ {"origin"=>"net/pacemaker2", "phase"=>"package", "errortype"=>"???"}
+ {"origin"=>"net/py-pynmsg", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"net/py-pypcap", "phase"=>"build", "errortype"=>"compiler_error"}
+ {"origin"=>"science/py-GPy", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"science/py-mlpy", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"security/morphis", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"security/py-keystone", "phase"=>"build", "errortype"=>"???"}
+ {"origin"=>"shells/ksh93-devel", "phase"=>"configure", "errortype"=>"configure_error"}
+ {"origin"=>"textproc/py-pyctpp2", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-http-parser", "phase"=>"build", "errortype"=>"clang"}
+ {"origin"=>"www/py-url", "phase"=>"build", "errortype"=>"clang"}

New failure logs:

http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-attic-0.16_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-astropy-1.1.2_2,1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/lv2-1.14.0_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-biom-format-2.1.7_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pymssql-2.1.3.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-datrie-0.7.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-efl-1.20.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-intbitset-2.3.0_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-jcc-3.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-llfuse-1.2_3.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-osc-lib-1.9.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pymtbl-0.4.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-python-gitlab-1.7.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-statgrab-0.7.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/pysvn-1.9.3.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/luxrender14-1.4_12.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-PyOpenGL-accelerate-3.1.0_2.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pyproj-1.9.5.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py27-notmuch-0.28.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-notmuch-0.28.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/pdal-1.7.2_6.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-PyMetis-2016.2.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-levmar-0.2.2_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-symcxx-0.1.9_2.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-glance-16.0.1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-libproxy-python-0.4.15.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/pacemaker1-1.1.19.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/pacemaker2-2.0.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pynmsg-0.4.0.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pypcap-1.2.2.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-GPy-1.9.6.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-mlpy-3.5.0_7.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/morphis-0.8.18.6_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-keystone-13.0.0_1.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/ksh93-devel-2019.02.14.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-pyctpp2-0.12.2_4.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-http-parser-0.8.3.log
http://package18.nyi.freebsd.org/data/112amd64-default-PR233770/2019-02-19_16h25m04s/logs/errors/py37-url-0.4.2_1.log

In my opinion python37 as default python3 won't happen before python36 is used as default python.
Comment 13 Dmitry Marakasov freebsd_committer 2019-04-05 23:49:48 UTC
Build fine with 3.7 and 3.8 ATM:

math/pdal
mail/py-notmuch
graphics/py-pyproj
databases/py-pymssql
devel/py-osc-lib

archivers/py-attic does not build on 12 due to OpenSSL incompatibility.
shells/ksh93-devel: fixed

Most others have similar problem with cython generated code which may be fixed with a rather simple patch.

My plan is
Phase 1: mark failing packages as python:-3.6
Phase 2: do another exp-run to see if this has broken other ports with 3.7, then try to fix as many packages as possible starting with most used ones.
Comment 14 Antoine Brodin freebsd_committer 2019-04-06 05:47:11 UTC
Note:

when limiting net/py-pypcap and science/py-GPy to python:-3.6,  you broke bulk -a
Comment 15 Antoine Brodin freebsd_committer 2019-11-20 15:27:42 UTC
@python : is this ready for another exp-run ??
Comment 16 Antoine Brodin freebsd_committer 2019-12-07 06:34:36 UTC
is the python team still active ?
Comment 17 Kubilay Kocak freebsd_committer freebsd_triage 2019-12-08 23:15:16 UTC
@Antoine, Yes, please re-run with 3.7 as default
Comment 18 commit-hook freebsd_committer 2019-12-11 16:33:19 UTC
A commit references this bug:

Author: antoine
Date: Wed Dec 11 16:32:31 UTC 2019
New revision: 519815
URL: https://svnweb.freebsd.org/changeset/ports/519815

Log:
  Fix packaging with non default version of python3

  PR:		233770

Changes:
  head/multimedia/openshot/pkg-plist
Comment 19 Antoine Brodin freebsd_committer 2019-12-11 17:00:45 UTC
A note before posting the exp-run results:

Limiting the python version for instance with USES=python:-3.6 is (most of the time) not a correct fix.

A correct fix is for instance:
- seeking if upstream released a new version including python 3.7 fixes
- patching python files or C files to make them compatible with python 3.7
- using a version of cython compatible with python 3.7 to regenerate C files
- marking the port BROKEN with py37 flavor, and deprecating it alongside all the ports depending on it if upstream and maintainer don't care
Comment 20 commit-hook freebsd_committer 2019-12-11 21:20:50 UTC
A commit references this bug:

Author: antoine
Date: Wed Dec 11 21:20:23 UTC 2019
New revision: 519840
URL: https://svnweb.freebsd.org/changeset/ports/519840

Log:
  Fix build with python 3.7

  PR:		233770

Changes:
  head/graphics/py-pivy-devel/files/patch-Inventor_nodes_SoMarkerSet.i
  head/graphics/py-pivy-devel/files/patch-Inventor_sensors_SoSensor.i
Comment 21 commit-hook freebsd_committer 2019-12-11 21:47:55 UTC
A commit references this bug:

Author: antoine
Date: Wed Dec 11 21:47:40 UTC 2019
New revision: 519843
URL: https://svnweb.freebsd.org/changeset/ports/519843

Log:
  Fix packaging/cleanup plist

  PR:		233770

Changes:
  head/korean/ibus-hangul/Makefile
  head/korean/ibus-hangul/pkg-plist
Comment 22 commit-hook freebsd_committer 2019-12-11 21:52:57 UTC
A commit references this bug:

Author: antoine
Date: Wed Dec 11 21:52:21 UTC 2019
New revision: 519845
URL: https://svnweb.freebsd.org/changeset/ports/519845

Log:
  Fix build with python 3.7

  PR:		233770

Changes:
  head/net/libproxy/Makefile
Comment 23 commit-hook freebsd_committer 2019-12-12 10:17:52 UTC
A commit references this bug:

Author: antoine
Date: Thu Dec 12 10:17:19 UTC 2019
New revision: 519859
URL: https://svnweb.freebsd.org/changeset/ports/519859

Log:
  Fix packaging

  PR:		233770

Changes:
  head/security/suricata5/pkg-plist
Comment 24 Tatsuki Makino 2019-12-13 01:26:30 UTC
(In reply to commit-hook from comment #18)
Thank you for correcting that the submitted pkg-plist was incorrect.

By the way, I'm curious about files that are placed in __pycache__.

When a user whose root or uid is 0 uses python with the -OO option, a file named *.opt-2.pyc is created in __pycache__. How can I handle this with pkg-plist etc?
Comment 25 commit-hook freebsd_committer 2019-12-13 09:41:41 UTC
A commit references this bug:

Author: antoine
Date: Fri Dec 13 09:41:04 UTC 2019
New revision: 520008
URL: https://svnweb.freebsd.org/changeset/ports/520008

Log:
  Fix build with python 3.7

  PR:		233770

Changes:
  head/graphics/opencv/files/patch-modules_python_src2_cv2.cpp
Comment 26 commit-hook freebsd_committer 2019-12-14 06:57:22 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 06:56:38 UTC 2019
New revision: 520089
URL: https://svnweb.freebsd.org/changeset/ports/520089

Log:
  Fix packaging

  PR:		233770

Changes:
  head/security/zeronet/pkg-plist
Comment 27 commit-hook freebsd_committer 2019-12-14 07:05:26 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 07:04:59 UTC 2019
New revision: 520090
URL: https://svnweb.freebsd.org/changeset/ports/520090

Log:
  Fix packaging

  PR:		233770

Changes:
  head/misc/hashdb/Makefile
  head/misc/hashdb/pkg-plist
Comment 28 commit-hook freebsd_committer 2019-12-14 08:38:34 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 08:38:24 UTC 2019
New revision: 520098
URL: https://svnweb.freebsd.org/changeset/ports/520098

Log:
  Fix packaging

  PR:		233770

Changes:
  head/misc/veles/pkg-plist
Comment 29 commit-hook freebsd_committer 2019-12-14 08:49:38 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 08:48:59 UTC 2019
New revision: 520101
URL: https://svnweb.freebsd.org/changeset/ports/520101

Log:
  Fix packaging

  PR:		233770

Changes:
  head/devel/ikos/Makefile
  head/devel/ikos/pkg-plist
Comment 30 commit-hook freebsd_committer 2019-12-14 09:00:41 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 09:00:31 UTC 2019
New revision: 520102
URL: https://svnweb.freebsd.org/changeset/ports/520102

Log:
  According to upstream, py-basemap is deprecated and only support python 2.7

  PR:		233770

Changes:
  head/math/py-basemap/Makefile
Comment 31 commit-hook freebsd_committer 2019-12-14 09:24:44 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 09:24:18 UTC 2019
New revision: 520103
URL: https://svnweb.freebsd.org/changeset/ports/520103

Log:
  Mark BROKEN with recent versions of python and deprecate

  PR:		233770

Changes:
  head/security/morphis/Makefile
Comment 32 commit-hook freebsd_committer 2019-12-14 14:57:23 UTC
A commit references this bug:

Author: kai
Date: Sat Dec 14 14:56:40 UTC 2019
New revision: 520122
URL: https://svnweb.freebsd.org/changeset/ports/520122

Log:
  devel/py-intbitset: Enable support for Python 3.7 and 3.8

  * Update to a more recent commit which contains a regenerated version of
    intbitset.c that was created with Cython 0.29.14 (not in Ports tree, yet).

    With the regenerated code the package can now also be built with
    Python 3.7 and 3.8.

  PR:		233770 (related)

Changes:
  head/devel/py-intbitset/Makefile
  head/devel/py-intbitset/distinfo
Comment 33 commit-hook freebsd_committer 2019-12-14 19:30:46 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 19:30:13 UTC 2019
New revision: 520139
URL: https://svnweb.freebsd.org/changeset/ports/520139

Log:
  Remove outdated astro/py-aipy

  PR:		233770
  With hat:	portmgr

Changes:
  head/MOVED
  head/astro/Makefile
  head/astro/py-aipy/
Comment 34 commit-hook freebsd_committer 2019-12-14 19:31:49 UTC
A commit references this bug:

Author: antoine
Date: Sat Dec 14 19:31:39 UTC 2019
New revision: 520140
URL: https://svnweb.freebsd.org/changeset/ports/520140

Log:
  Update astro/py-astropy to 3.1.2

  PR:		233770

Changes:
  head/astro/py-RO/Makefile
  head/astro/py-astLib/Makefile
  head/astro/py-astropy/Makefile
  head/astro/py-astropy/distinfo
  head/astro/py-astropy/files/patch-astropy_io_fits_setup__package.py
  head/astro/py-astropy/files/patch-astropy_wcs_setup__package.py
Comment 35 commit-hook freebsd_committer 2019-12-15 12:43:07 UTC
A commit references this bug:

Author: antoine
Date: Sun Dec 15 12:42:28 UTC 2019
New revision: 520175
URL: https://svnweb.freebsd.org/changeset/ports/520175

Log:
  Fix plist

  PR:		233770

Changes:
  head/java/intellij-rubymine/pkg-plist
Comment 36 commit-hook freebsd_committer 2019-12-15 15:49:23 UTC
A commit references this bug:

Author: antoine
Date: Sun Dec 15 15:49:20 UTC 2019
New revision: 520182
URL: https://svnweb.freebsd.org/changeset/ports/520182

Log:
  Fix plist

  PR:		233770

Changes:
  head/math/saga/pkg-plist
Comment 37 commit-hook freebsd_committer 2019-12-15 16:58:30 UTC
A commit references this bug:

Author: antoine
Date: Sun Dec 15 16:57:35 UTC 2019
New revision: 520184
URL: https://svnweb.freebsd.org/changeset/ports/520184

Log:
  Fix plist

  PR:		233770

Changes:
  head/print/system-config-printer/pkg-plist
Comment 38 commit-hook freebsd_committer 2019-12-15 17:01:33 UTC
A commit references this bug:

Author: antoine
Date: Sun Dec 15 17:00:33 UTC 2019
New revision: 520185
URL: https://svnweb.freebsd.org/changeset/ports/520185

Log:
  Mark BROKEN with recent versions of python, deprecate

  PR:		233770

Changes:
  head/misc/py-glance/Makefile
Comment 39 commit-hook freebsd_committer 2019-12-16 06:29:30 UTC
A commit references this bug:

Author: antoine
Date: Mon Dec 16 06:29:00 UTC 2019
New revision: 520219
URL: https://svnweb.freebsd.org/changeset/ports/520219

Log:
  Switch default version of python3 and python from 3.6 to 3.7

  With hat:	portmgr
  PR:		233770

Changes:
  head/Mk/Uses/python.mk
  head/Mk/bsd.default-versions.mk